// ABLock.cpp 
//

#include "stdafx.h"
#include "AccessControl1s.h"
#include "ABLock.h"

IMPLEMENT_DYNAMIC(ABLock, CDialog)

ABLock::ABLock(CWnd* pParent /*=NULL*/)
	: CDialog(ABLock::IDD, pParent)
{
	memset(&m_stuInfo,0,sizeof(m_stuInfo));
}

ABLock::~ABLock()
{
}

void ABLock::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ABLOCK_CHE_ENABLE, m_cbeLockEnable);
	DDX_Control(pDX, IDC_ABLOCK_COM_GROUPNUM, m_comABLockGroupNO);
}


BEGIN_MESSAGE_MAP(ABLock, CDialog)
	ON_BN_CLICKED(IDC_ABLOCK_BUT_GET, &ABLock::OnBnClickedAblockButGet)
	ON_BN_CLICKED(IDC_ABLOCK_BUT_SET, &ABLock::OnBnClickedAblockButSet)
	ON_CBN_SELCHANGE(IDC_ABLOCK_COM_GROUPNUM, &ABLock::OnCbnSelchangeAblockComGroupnum)
	ON_CBN_SETFOCUS(IDC_ABLOCK_COM_GROUPNUM, &ABLock::OnCbnSetfocusAblockComGroupnum)
END_MESSAGE_MAP()

BOOL ABLock::OnInitDialog()
{
	CDialog::OnInitDialog();
	g_SetWndStaticText(this);
	InitDlg();
	if (Device::GetInstance().GetLoginState())
	{
		OnBnClickedAblockButGet();
	}
	else
	{
		MessageBox(ConvertString("Not login yet!"), ConvertString("Prompt"));
		GetDlgItem(IDC_ABLOCK_BUT_GET)->EnableWindow(FALSE);
		GetDlgItem(IDC_ABLOCK_BUT_SET)->EnableWindow(FALSE);
	}
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void ABLock::OnBnClickedAblockButGet()
{
	BOOL bret = Device::GetInstance().GetAccessGeneralInfo(m_stuInfo);
	if (bret)
	{
		SetABLockInfoToCtrl();
	}
	else
	{
		CString csInfo;
		csInfo.Format("%s0x%08x", ConvertString("Get config failed:"), CLIENT_GetLastError());
		MessageBox(csInfo, ConvertString("Prompt"));
	}
}

void ABLock::OnBnClickedAblockButSet()
{
	GetABLockInfoFromCtrl();
	BOOL bret = Device::GetInstance().SetAccessGeneralInfo(&m_stuInfo);
	if (!bret)
	{
		CString csInfo;
		csInfo.Format("%s0x%08x", ConvertString("Set config failed:"), CLIENT_GetLastError());
		MessageBox(csInfo, ConvertString("Prompt"));
	}
}

void ABLock::SetABLockInfoToCtrl()
{
	m_comABLockGroupNO.SetCurSel(0);

	for (int i=0;i<4;i++)
	{
		SetDlgItemText(IDC_ABLOCK_EDIT_DOORID1+i, "");
	}
	if (m_stuInfo.stuABLockInfo.bEnable)
	{
		m_cbeLockEnable.SetCheck(TRUE);
	}
	else
	{
		m_cbeLockEnable.SetCheck(FALSE);
	}

	for (int i=0;i<m_stuInfo.stuABLockInfo.stuDoors[0].nDoor;i++)
	{
		SetDlgItemInt(IDC_ABLOCK_EDIT_DOORID1+i, m_stuInfo.stuABLockInfo.stuDoors[0].anDoor[i]);
	}
}

void ABLock::GetABLockInfoFromCtrl()
{
	int nABLockGroupNO = m_comABLockGroupNO.GetCurSel();

	if (m_cbeLockEnable.GetCheck())
	{
		m_stuInfo.abABLockInfo = true;
		m_stuInfo.stuABLockInfo.bEnable = TRUE;
	}
	else
	{
		m_stuInfo.abABLockInfo = false;
		m_stuInfo.stuABLockInfo.bEnable = FALSE;
	}
	
	for (int i=0;i<CFG_MAX_ABLOCK_DOORS_NUM;i++)
	{
		CString str = "";
		GetDlgItemText(IDC_ABLOCK_EDIT_DOORID1+i,str);
		if (str.IsEmpty())
		{
			m_stuInfo.stuABLockInfo.stuDoors[nABLockGroupNO].nDoor = i;
			break;
		}
		else
		{
			m_stuInfo.stuABLockInfo.stuDoors[nABLockGroupNO].anDoor[i] = GetDlgItemInt(IDC_ABLOCK_EDIT_DOORID1+i);
		}
	}

	for (int i=0;i<CFG_MAX_ABLOCK_GROUP_NUM;i++)
	{
		int ndoor = m_stuInfo.stuABLockInfo.stuDoors[i].nDoor;
		if (ndoor == 0)
		{
			m_stuInfo.stuABLockInfo.nDoors = i;
			break;
		}
	}
}	

void ABLock::InitDlg()
{
	int i = 0;
	m_comABLockGroupNO.ResetContent();
	for (i = 0; i < CFG_MAX_ABLOCK_GROUP_NUM; i++)
	{
		CString csInfo;
		csInfo.Format("%d", i);
		m_comABLockGroupNO.InsertString(-1, csInfo);
	}
	m_comABLockGroupNO.SetCurSel(0);

}
void ABLock::OnCbnSelchangeAblockComGroupnum()
{
	//ʾµֵ
	for (int i=0;i<4;i++)
	{
		SetDlgItemText(IDC_ABLOCK_EDIT_DOORID1+i, "");
	}

	int nABLockGroupNO = m_comABLockGroupNO.GetCurSel();

	for (int i=0;i<m_stuInfo.stuABLockInfo.stuDoors[nABLockGroupNO].nDoor;i++)
	{
		SetDlgItemInt(IDC_ABLOCK_EDIT_DOORID1+i, m_stuInfo.stuABLockInfo.stuDoors[nABLockGroupNO].anDoor[i]);
	}

}

void ABLock::OnCbnSetfocusAblockComGroupnum()
{
	//µǰֵ
	int nABLockGroupNO = m_comABLockGroupNO.GetCurSel();

	for (int i=0;i<CFG_MAX_ABLOCK_DOORS_NUM;i++)
	{
		CString str = "";
		GetDlgItemText(IDC_ABLOCK_EDIT_DOORID1+i,str);
		if (str.IsEmpty())
		{
			m_stuInfo.stuABLockInfo.stuDoors[nABLockGroupNO].nDoor = i;
			break;
		}
		else
		{
			m_stuInfo.stuABLockInfo.stuDoors[nABLockGroupNO].anDoor[i] = GetDlgItemInt(IDC_ABLOCK_EDIT_DOORID1+i);
		}
	}

	for (int i=0;i<CFG_MAX_ABLOCK_GROUP_NUM;i++)
	{
		int ndoor = m_stuInfo.stuABLockInfo.stuDoors[i].nDoor;
		if (ndoor == 0)
		{
			m_stuInfo.stuABLockInfo.nDoors = i;
			break;
		}
	}
}
